#!/usr/bin/lua

function indexOf(data, ch, s, e)
	if e == nil then
		e = data:len()
	end
	if s == nil then
		s = 0
	end
	for i = s, e do
		if data:byte(i) == ch:byte() then
			return i
		end
	end
	return nil
end

local rc_local_clear = 
[[rm -f /etc/rc.d/S19patch_bdata.sh
rm -f /etc/init.d/patch_bdata.lua]]

local tmp_dir = io.popen("printf $(mktemp -d /tmp/patch_bdata.lua.XXXXXX)"):read("*all")
local crash = io.popen([[printf /dev/$(printf $(cat /proc/mtd | grep -w crash | sed -e 's/\(mtd[0-9]*\).*/\1/'))]]):read("*all")
if io.popen([[hexdump -v -n 4 -e '1/1 "%02x"' ]]..([["%s"]]):format(crash)):read("*all") ~= "a55a0000" then
	if io.popen("command -v /etc/rc.d/S19patch_bdata.sh"):read("*all") ~= "" then
		os.execute(rc_local_clear)
		os.exit(1)
	end
	local i = 1
	local patch_bdata_cmd = "/etc/init.d/patch_bdata.lua"
	while arg[i] ~= nil do
		patch_bdata_cmd = ("%s %s"):format(patch_bdata_cmd, arg[i])
		i = i + 1
	end
	os.execute((
[[echo "#!/bin/sh" > /etc/rc.d/S19patch_bdata.sh
echo "%s" >> /etc/rc.d/S19patch_bdata.sh
chmod 755 /etc/rc.d/S19patch_bdata.sh
[ "%s" != "/etc/init.d/patch_bdata.lua" ] && cp -f %s /etc/init.d/patch_bdata.lua
chmod 755 /etc/init.d/patch_bdata.lua
mtd erase crash
printf "\xa5\x5a\x00\x00" > "%s/crash"
dd if=%s bs=4 skip=1 2>/dev/null >> "%s/crash"
mtd write "%s/crash" crash
reboot]]
	):format(patch_bdata_cmd, arg[0], arg[0], tmp_dir, crash, tmp_dir, tmp_dir))
	os.exit(0);
end

os.execute(rc_local_clear);

local bdata_path = io.popen([[printf /dev/$(printf $(cat /proc/mtd | grep -w bdata | sed -e 's/\(mtd[0-9]*\).*/\1/'))]]):read("*all")
local bdata = io.open(bdata_path, "rb"):read(0x10000)
local entries = {}
local i = 5
while true do
	local s = indexOf(bdata, string.char(0), i) or bdata:len()
	if s > i then
		local entry = bdata:sub(i, s - 1)
		i = s + 1
		s = indexOf(entry, '=')
		if s ~= nil then
			entries[entry:sub(1, s - 1)] = entry:sub(s + 1)
		end
	else
		break
	end
end

entries['boot_wait'] = "on"
entries['telnet_en'] = 1
entries['uart_en'] = 1
entries['ssh_en'] = 1

local i = 1
while arg[i] ~= nil do
	local c = 2
	while c <= arg[i]:len() do
		if arg[i]:byte(c) == ("="):byte() then
			entries[arg[i]:sub(1, c - 1)] = arg[i]:sub(c + 1)
			break
		end
		c = c + 1
	end
	i = i + 1
end

local entries_size = 0
for k, v in pairs(entries) do
	local entry = ("%s=%s"):format(k, v)
	local next_size = entries_size + entry:len() + 1
	if next_size >= 0xfffb then
		break
	end
	os.execute(([[printf "%s" >> "%s/entries"; dd if=/dev/zero bs=1 count=1 2>/dev/null >> "%s/entries";]]):format(entry, tmp_dir, tmp_dir))
	entries_size = next_size
end
os.execute(([[dd if=/dev/zero bs=1 count=%s 2>/dev/null >> "%s/entries"]]):format(0xfffc - entries_size, tmp_dir))
local crc = tonumber(io.popen(([[printf $((0xffffffff - $(dd if="%s/entries" 2>/dev/null | ubicrc32)))]]):format(tmp_dir)):read("*all"))
if crc == nil or crc > (2 ^ 32 - 1) then
	os.execute([[rm -f "/etc/patch_bdata.lua"]]);
	os.exit(1)
end
os.execute(([[printf "\x%02x\x%02x\x%02x\x%02x" > "%s/bdata.img"]]):format(
	crc % 0x100,
	((crc % 0x10000) - (crc % 0x100)) / 0x100,
	((crc % 0x1000000) - (crc % 0x10000)) / 0x10000,
	(crc - (crc % 0x1000000)) / 0x1000000,
	tmp_dir
))
os.execute((
[[dd if="%s/entries" 2>/dev/null >> "%s/bdata.img"
dd if=%s bs=%s skip=1 2>/dev/null >> "%s/bdata.img"
mtd write "%s/bdata.img" bdata
mtd erase crash
reboot]]
):format(tmp_dir, tmp_dir, bdata_path, 0x10000, tmp_dir, tmp_dir))

os.exit(0)
